<?php

include_once(dirname(__FILE__).'/../../files/db1.php');
$freifeld_db_host=$db_host; //Database host
$freifeld_db_username=$db_username; //Database login
$freifeld_db_password=$db_password; //Database password
$freifeld_db_name=$db_name; //Name of the host database

$freifeld_version="0.9.1";
$freifeld_db_prefix = "LOG_";
$freifeld_ajax_base="http".(isset($_SERVER['HTTPS'])?"s":"")."://".$_SERVER['SERVER_NAME']."/";
$freifeld_ajax_url=$freifeld_ajax_base."freifeld_ajax.php";
$latestHistoryEntry="";

// verfügbare Sprachen
$al=array("en","de");

// no/full error reporting:
error_reporting(0); //E_ALL);
ini_set('display_errors', '0'); //1');

connectDb();

if (!isset($onlyConnect)) {
  header("Content-Type: text/html;charset=UTF-8");

  if (!empty($_POST)) {
      if ($_POST["do"] != null) {
        if ($_POST["do"] == "writeEntry") {
          loadSubject($_POST["hash"]);
          writeEntry($_POST["name"], str_replace(array("_q", "_a", "_g", "_l", "_u"), array("\"", "'", ">", "<", "_"), $_POST["value"]));
        } else if ($_POST["do"] == "getDiff") {
          loadSubject($_POST["hash"]);
          $a=getDiff($_POST["from"], $_POST["to"]);
          echo "{";
          foreach($a as $n=>$v) {
            echo("\"".$n."\": \"".str_replace(array("\n", "\""), array(" ", "\\\""), $v)."\",\n");
          }
          echo("\"ts\": \"".$_POST["to"]."\"\n");
          echo("}");
        } else if ($_POST["do"] == "getHistory") {
          loadSubject($_POST["hash"]);
          $h=getHistory();
          echo "{";
          for($i=0; $i < sizeof($h); $i++) {
            echo("\"h".$i."\": \"".str_replace(array("\n", "\""), array(" ", "\\\""), $h[$i])."\",\n");
          }
          echo("\"c\": \"".sizeof($h)."\"\n");
          echo("}");
        } 
        exit();
      }
  }

  if (!isset($freifeld_hash)) {
    $freifeld_hash=$_SERVER["QUERY_STRING"];
  }
  $id=-1;
  $onchange="";
  loadSubject($freifeld_hash);
  
  // include_once html-part
  echo('<script type="text/javascript" src="'.$freifeld_ajax_base.'js/freifeld.js"></script>'."\n");

  $h=getHistory();
  $latestHistoryEntry=$h[0]; 
  $a=getDiff("0", "2999");
  echo('<script type="text/javascript">'."\n");
  echo('var freifeld_ajax_base="'.$freifeld_ajax_base.'";'."\n");
  echo('var freifeld_ajax="'.$freifeld_ajax_url.'";'."\n");
  echo('$(document).ready(function() {'."\n");
  echo("  init('".$freifeld_hash."', '".$h[0]."');"."\n");
  echo('});'."\n");
  echo('</script>'."\n");
  echo('<style>'."\n");
  echo('.editable {'."\n");
  echo('  background:#ddddff;'."\n");
  echo('  width:100%;'."\n");
  echo('  height:100%;'."\n");
  echo('}'."\n");
  echo('</style>'."\n");
}

// replace single quote with two single quotes for sql-injection prevention
function p($param) {
  if (get_magic_quotes_gpc() == 1) {
    $r=stripslashes($param);  
  } else {
    $r=$param;  
  } 
  // workaround for migration-data-fix 1.5
  if (strpos($r, '\"') !== false) {
    $r=stripslashes($param);  
  }
  $r=str_replace("'", "''", $r);
  return $r;
}

function h($param) {
  if (get_magic_quotes_gpc() == 1) {
    $r=stripslashes($param);  
  } else {
    $r=$param;  
  } 
  // workaround for migration-data-fix 1.5
  if (strpos($r, '\"') !== false) {
    $r=stripslashes($param);  
  }
  $r=htmlspecialchars($r);
  return $r;
}

function connectDb() {
  global $freifeld_db_host;
  global $freifeld_db_username;
  global $freifeld_db_password;
  global $freifeld_db_name;

  //CONNECT TO DB
  $dbcnx = @mysql_connect($freifeld_db_host, $freifeld_db_username, $freifeld_db_password);
  if (!$dbcnx) {
      fail("Datenbank nicht erreichbar, bitte später erneut versuchen");
  }
  mysql_query("SET NAMES 'utf8'");
  //Select the database
  if (!@mysql_select_db($freifeld_db_name)) {
      fail("Datenbank nicht korrekt konfiguriert");
  }
}

function createSubject($freifeld_hash, $mail) {
  global $freifeld_db_prefix;
  $insert = @mysql_query("INSERT INTO " . $freifeld_db_prefix . "SUBJECT SET hash='".p($freifeld_hash)."', onchange='".p($mail)."'");
  if (!$insert) {
    fail("insert failed");
  }
}

function setOnChange($freifeld_hash, $mail) {
  global $freifeld_db_prefix;
  $update = @mysql_query("UPDATE " . $freifeld_db_prefix . "SUBJECT SET onchange='".p($mail)."' WHERE hash='".p($freifeld_hash)."'");
  if (!$update) {
    fail("update failed");
  }
}

function deleteForm($freifeld_hash) {
  global $freifeld_db_prefix;
  $sql = @mysql_query("SELECT id FROM " . $freifeld_db_prefix . "SUBJECT WHERE hash='".p($freifeld_hash)."'");
  if ($row = mysql_fetch_array($sql)) {
    $id=$row["id"];
    $delete = @mysql_query("DELETE FROM " . $freifeld_db_prefix . "HISTORY WHERE id_subject=".$id);
    if (!$delete) {
      fail("history delete failed");
    }
    $delete2 = @mysql_query("DELETE FROM " . $freifeld_db_prefix . "SUBJECT WHERE id=".$id);
    if (!$delete2) {
      fail("delete failed");
    }
  } else {
    echo("no such form");
  }
}

function writeEntry($name, $value) {
  global $freifeld_db_prefix;
  global $domain;
  global $freifeld_hash;
  global $id;
  global $title;
  global $onchange;
  $insert = @mysql_query("INSERT INTO " . $freifeld_db_prefix . "HISTORY SET id_subject=$id, `NAME`='".p($name)."', `VALUE`='".p($value)."'");
  if (!$insert) {
    fail("insert failed");
  }
  if (strpos($onchange, "@") !== FALSE) {
    mail($onchange, "[notify] edited ".$title, $domain."?".$freifeld_hash."\r\nNeuer Wert in ".$name.": ".$value, "From: noreply@emphasize.de\r\nContent-Type: text/plain; charset=utf-8\r\nContent-Transfer-Encoding: 8bit\r\n\r\n");
  }
}

function loadSubject($ahash) {
  global $freifeld_db_prefix;
  global $freifeld_hash;
  global $id;
  global $onchange;
  
  for ($retry=0; $retry<2; $retry++) {
    $sql = @mysql_query("SELECT id, onchange FROM " . $freifeld_db_prefix . "SUBJECT WHERE hash='".p($ahash)."'");
    if ($row = mysql_fetch_array($sql)) {
      $id=$row["id"];
      $onchange=$row["onchange"];
      break;
    } else {
      mysql_free_result($sql);
      createSubject($ahash, "");
    }
  }
  $freifeld_hash=$ahash;
  mysql_free_result($sql);
}

function reduceHistory() {
  global $freifeld_db_prefix;
  global $id;
  $insert = @mysql_query("INSERT INTO " . $freifeld_db_prefix . "HISTORY(id_subject, `name` , `value` ) SELECT -id_subject, `name` , `value` FROM (SELECT t0.id_subject, t0.`name` , t0.`value` FROM " . $freifeld_db_prefix . "HISTORY t0 WHERE t0.id_subject =".$id." AND t0.ts <= '9999' AND t0.`name` IN (SELECT t1.`name` FROM " . $freifeld_db_prefix . "HISTORY t1 WHERE t1.id_subject =".$id." AND t1.ts <= '9999' AND t1.ts > '0') ORDER BY t0.ts DESC) AS TMP GROUP BY `name`");
  if (!$insert) {
    fail("insert failed");
  }
  $delete = @mysql_query("DELETE FROM " . $freifeld_db_prefix . "HISTORY WHERE id_subject =".$id);
  if (!$delete) {
    fail("delete failed");
  }
  $update = @mysql_query("UPDATE " . $freifeld_db_prefix . "HISTORY SET id_subject =".$id." WHERE id_subject =-".$id);
  if (!$update) {
    fail("update failed");
  }
}

function writeHistoryControl() {
global $latestHistoryEntry;
global $freifeld_ajax_base;

echo('letzte Änderung: <i><span id="latest">'.$latestHistoryEntry.'</span></i>&nbsp;&nbsp;<img id="doing" src="'.$freifeld_ajax_base.'graphics/doing.gif" width="32" height="32" style="vertical-align:middle;"></img><br/>
<img id="end" src="'.$freifeld_ajax_base.'graphics/de.png" width="32" height="32" title="zum neuesten Eintrag" class="history"></img>
<img id="back" src="'.$freifeld_ajax_base.'graphics/db.png" width="32" height="32" title="zum folgenden Eintrag"  class="history"></img>
<b><span id="current" style="width:50px; text-align:center;">'.$latestHistoryEntry.'</span></b>
<img id="forward" src="'.$freifeld_ajax_base.'graphics/df.png" width="32" height="32" title="zum vorherigen Eintrag" class="history"></img>
<img id="start" src="'.$freifeld_ajax_base.'graphics/ds.png" width="32" height="32" title="zum ersten Eintrag" class="history"></img>');
}

function getHistory() {
  global $freifeld_db_prefix;
  global $id;
  $a=array();
  $sql = @mysql_query("SELECT `ts` FROM " . $freifeld_db_prefix . "HISTORY WHERE id_subject=$id GROUP BY `ts` ORDER BY `ts` DESC");
  while ($row = mysql_fetch_array($sql)) {
    $ts=$row["ts"];
    $a[]=$ts;
  }
  mysql_free_result($sql);
  return $a;
}

function getDiff($lo, $hi) {
  global $freifeld_db_prefix;
  global $id;
  $a=array();
  if ($lo <= $hi) {
    $sql = @mysql_query("SELECT `name`, `value` FROM (SELECT `name`, `value` FROM " . $freifeld_db_prefix . "HISTORY WHERE id_subject=$id AND ts<='$hi' AND ts>'$lo' ORDER BY ts DESC) AS TMP GROUP BY `name`");
  } else {
    // leer vorbelegen
    $sql = @mysql_query("SELECT `name` FROM " . $freifeld_db_prefix . "HISTORY WHERE id_subject=$id AND ts<='$lo' AND ts>'$hi' GROUP BY `name`");
    while ($row = mysql_fetch_array($sql)) {
      $n=$row["name"];
      $a[$n]="";
    }
    mysql_free_result($sql);
    // mit pre-range inhalten füllen
    $sql = @mysql_query("SELECT `name`, `value` FROM (SELECT t0.`name`, t0.`value` FROM " . $freifeld_db_prefix . "HISTORY t0 WHERE t0.id_subject=$id AND t0.ts<='$hi' AND t0.`name` IN (SELECT t1.`name` FROM " . $freifeld_db_prefix . "HISTORY t1 WHERE t1.id_subject=$id AND t1.ts<='$lo' AND t1.ts>'$hi') ORDER BY t0.ts DESC) AS TMP GROUP BY `name`");
  }
  while ($row = mysql_fetch_array($sql)) {
    $n=$row["name"];
    $v=$row["value"];
    $a[$n]=$v;
  }
  mysql_free_result($sql);
  return $a;
}

function latest($n, $default='&nbsp;') {
  global $a;
  if (isset($a[$n])) { 
    echo($a[$n]); 
  } else { 
    echo($default);
  }
}

function detectLang()
{
	global $al;
	global $lang;

	if (isset($lang) && strlen($lang)>1) {
		// use $lang
	} else if (isset($_GET["lang"]) && $_GET["lang"] != "") {
		$lang=$_GET["lang"];
		$_SESSION['lang']=$lang;
	} else if (isset($_POST["lang"]) && $_POST["lang"] != "") {
		$lang=$_POST["lang"];
		$_SESSION['lang']=$lang;
	} else if (isset($_SESSION['lang'])) {
		$lang=$_SESSION['lang'];
	} else {
	  $lang="";
	}

	if ($lang == "") {
		$langs = $al;

		$_AL=strtolower($_SERVER['HTTP_ACCEPT_LANGUAGE']);
		$_UA=strtolower($_SERVER['HTTP_USER_AGENT']);

		foreach($langs as $K) {
			if(strpos($_AL, $K)===0)
				return $K;
		}

		foreach($langs as $K) {
			if(strpos($_AL, $K)!==false)
				return $K;
		}
		foreach($langs as $K) {
			if ((strpos($_UA, "[".$K.";")!==false) ||
					(strpos($_UA, "(".$K.";")!==false) ||
					(strpos($_UA, " ".$K.";")!==false) ||
					(strpos($_UA, "[".$K.",")!==false) ||
					(strpos($_UA, "(".$K.",")!==false) ||
					(strpos($_UA, " ".$K.",")!==false) ||
					(strpos($_UA, "[".$K."_")!==false) ||
					(strpos($_UA, "(".$K."_")!==false) ||
					(strpos($_UA, " ".$K."_")!==false) ||
					(strpos($_UA, "[".$K."-")!==false) ||
					(strpos($_UA, "(".$K."-")!==false) ||
					(strpos($_UA, " ".$K."-")!==false) ||
					(strpos($_UA, "[".$K.")")!==false) ||
					(strpos($_UA, "(".$K.")")!==false) ||
					(strpos($_UA, " ".$K.")")!==false))
				return $K;
		}

		return "en";
	}
	return $lang;
}
?>
